<template>
<el-container style="height: calc(100vh)">
	<el-container >
    <el-container class="nav" :class="{navCollapsed: isCollapse}">
			<el-aside width="100%">
				<el-menu default-active="2" class="el-menu-nav"   router
					:collapse-transition="false" :collapse="isCollapse"
					background-color="#304156"
					text-color="#fff"
					active-text-color="#CDCF96">
					<template v-for="(r, i) in rutasNavegables">
						<el-sub-menu v-if="r.menu" :index="`${i}`" :key="r.name">
							<template v-slot:title>
								<el-icon ><component :is="r.icon" /></el-icon>
								<span>{{r.name}}</span>
							</template>
							<el-menu-item v-for="r2 in r.items" :key="r2.path" :index="r2.path"
								:router="true" :default-active="`${r.path}`">
								<el-icon ><component :is="r2.icon" /></el-icon>
								<template v-slot:title>
									<span >{{r2.name}}</span>
								</template>
							</el-menu-item>
						</el-sub-menu>
						<el-menu-item v-else :key="r.name" :index="r.path"
							:router="true" :default-active="`${r.path}`">
							<el-icon ><component :is="r.icon" /></el-icon>
							<template v-slot:title>
								<span >{{r.name}}</span>
							</template>
						</el-menu-item>
					</template>
				</el-menu>
			</el-aside>
    </el-container>
    <el-container class="main" :class="{mainCollapsed: isCollapse}">
      <el-container class="main-container" >
				<router-view />
			</el-container>
			<el-footer class="app" height="20px">
				<!-- <span>copyleft &#x1f12f; 2021 MIND</span> -->
			</el-footer>
    </el-container>
  </el-container>
</el-container>
</template>

<script>
import app from '../model/app'
// import {ref} from 'vue'
import * as api from '../helper/fetch'
api.Options.parseJson = true;
api.Options.responseData = 'data';




export default {
  name: 'mind-app',
  components: {
	},
	// setup() {
	// 	let isCollapse = ref(false)
	// 	return { isCollapse }
	// },
	created(){

		api.Options.onError = (error) => {
			if(error && error.message) {
				error = error.message
			}
			this.$message({
				type: 'error',
				title: "Error",
				message: `${error}`,
				showClose: true,
				duration: 5000,
				grouping: true,
			});
		}
	console.log(this.rutasNavegables)

    this.$router.beforeEach((to, from, next) => {
      // let uri = to.matched[0]?.meta?.api || '/auth-verify';
      let uri = '/auth-verify';
      //chequeo permisos a la api
      if (uri) {
        fetch(uri, { credentials: "same-origin", redirect: "error" })
          .then(response => {
            switch (response.status) {
              case 302:
								location.reload()
								return
              case 401:
								this.$alert('Presione "Continuar" para volver a ingresar', 'Sesión Finalizada', {
									confirmButtonText: 'Continuar',
									callback: () => {
										location.reload(true)
										// location.href = '/auth'
									}
								});
								return
              case 403:
								this.$message({
									type: "error",
									showClose: true,
									message: 'No Autorizado '
								});
								break
              case 404:
              case 200:
                next();
                break;
              default:
                break;
            }
          })
          .catch(error => {
						console.log(error)

						this.$message({
							type: "error",
							showClose: true,
							message: error.message
						});

          });
      } else {
        next();
      }
		});
	},

	computed: {
		rutasNavegables() {
			let rutas = this.$router.options.routes
			let res = []
			rutas =  rutas.filter(ruta => !!ruta.meta?.nav);
			let index = {}

			for(const r of rutas) {
				if(r.meta.nav.menu) {
					if(!index[r.meta.nav.menu]) {
						index[r.meta.nav.menu] = []
						res.push({
							name: r.meta.nav.menu,
							menu: true,
							items: index[r.meta.nav.menu],
							icon: r.meta.nav.menuIcon || 'Tools'
						})
					}
					index[r.meta.nav.menu].push({
						name: r.name,
						menu: false,
						path: r.path,
						icon: r.meta.nav.icon
					})
				} else {
					res.push({
						name: r.name,
						menu: false,
						path: r.path,
						icon: r.meta.nav.icon
					})
				}
			}


			return res
		},
		isCollapse:{
			get() {
				return app.isCollapse
			},
			set(v) {
				app.isCollapse = v
			}
		}
	},
	methods:{
	},
	data() {
		return {
		}
	}

}
</script>

<style scoped>

#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}



 </style>

<style>
.nav {
	-webkit-transition: width .28s;
	transition: width .280s;
	width: 210px !important;
	background-color: #304156;
	height: 100%;
	position: fixed;
	font-size: 0;
	top: 0;
	bottom: 0;
	left: 0;
	z-index: 1001;
	overflow: hidden;
}

.navCollapsed {
	width: 64px !important;
}

.main {
	margin-left: 210px;
	transition: margin-left .280s;
	/* position:absolute;
	height: 100%;
	width: calc(100% - 210px); */
}

.mainCollapsed {
	margin-left: 64px;
}

.el-main {
	padding: 10px;
	overflow-x: hidden !important;
}

.main-container {
	height:calc(100% - 50px)
}


.el-col {
	height: 100%;
}

.el-menu-nav {
	height: calc(100% );
	overflow: auto;
}

.el-menu {
border: none;
}

.el-footer.app {
	font-family: Helvetica Neue,Helvetica,PingFang SC,Hiragino Sans GB,Microsoft YaHei,Arial,sans-serif;
	font-size: 10px;
	color: white;
	background-color:#304156;
	line-height: 20px;
}


.el-collapse-item__header {
	padding-left: 10px;
	height: 30px;
	line-height: 30px;
	-webkit-transition: background .5s;
	transition: background .5s;
}

.el-collapse-item__header:hover {
	background: rgba(0,0,0,.1);
}

/* .el-collapse-item__header.is-active {
	background: rgba(0,0,0,.1);
} */


.el-dialog {
	max-height: calc(100% - 20vh);
	overflow: hidden;
}

.el-dialog__body {
	/* max-height: calc(50vh); */
	display: flex;
	overflow: auto;
	padding: 5px 30px !important;
}

.el-form-item {
	margin-bottom: 5px !important;
}

.el-form-item--mini.el-form-item, .el-form-item--small.el-form-item {
	margin-bottom: 5px !important;
}
</style>
